<?php
if (session_id() == "") session_start(); // Init session data
ob_start(); // Turn on output buffering
?>
<?php include_once "ewcfg14.php" ?>
<?php include_once ((EW_USE_ADODB) ? "adodb5/adodb.inc.php" : "ewmysql14.php") ?>
<?php include_once "phpfn14.php" ?>
<?php include_once "pesertainfo.php" ?>
<?php include_once "employeesinfo.php" ?>
<?php include_once "userfn14.php" ?>
<?php

//
// Page class
//

$peserta_addopt = NULL; // Initialize page object first

class cpeserta_addopt extends cpeserta {

	// Page ID
	var $PageID = 'addopt';

	// Project ID
	var $ProjectID = '{CC60B42B-604B-412A-B014-2315920AF6AA}';

	// Table name
	var $TableName = 'peserta';

	// Page object name
	var $PageObjName = 'peserta_addopt';

	// Page headings
	var $Heading = '';
	var $Subheading = '';

	// Page heading
	function PageHeading() {
		global $Language;
		if ($this->Heading <> "")
			return $this->Heading;
		if (method_exists($this, "TableCaption"))
			return $this->TableCaption();
		return "";
	}

	// Page subheading
	function PageSubheading() {
		global $Language;
		if ($this->Subheading <> "")
			return $this->Subheading;
		if ($this->TableName)
			return $Language->Phrase($this->PageID);
		return "";
	}

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		if ($this->UseTokenInUrl) $PageUrl .= "t=" . $this->TableVar . "&"; // Add page token
		return $PageUrl;
	}

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_MESSAGE], $v);
	}

	function getFailureMessage() {
		return @$_SESSION[EW_SESSION_FAILURE_MESSAGE];
	}

	function setFailureMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_FAILURE_MESSAGE], $v);
	}

	function getSuccessMessage() {
		return @$_SESSION[EW_SESSION_SUCCESS_MESSAGE];
	}

	function setSuccessMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_SUCCESS_MESSAGE], $v);
	}

	function getWarningMessage() {
		return @$_SESSION[EW_SESSION_WARNING_MESSAGE];
	}

	function setWarningMessage($v) {
		ew_AddMessage($_SESSION[EW_SESSION_WARNING_MESSAGE], $v);
	}

	// Methods to clear message
	function ClearMessage() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
	}

	function ClearFailureMessage() {
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
	}

	function ClearSuccessMessage() {
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
	}

	function ClearWarningMessage() {
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	function ClearMessages() {
		$_SESSION[EW_SESSION_MESSAGE] = "";
		$_SESSION[EW_SESSION_FAILURE_MESSAGE] = "";
		$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = "";
		$_SESSION[EW_SESSION_WARNING_MESSAGE] = "";
	}

	// Show message
	function ShowMessage() {
		$hidden = FALSE;
		$html = "";

		// Message
		$sMessage = $this->getMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sMessage, "");
		if ($sMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sMessage;
			$html .= "<div class=\"alert alert-info ewInfo\">" . $sMessage . "</div>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}

		// Warning message
		$sWarningMessage = $this->getWarningMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sWarningMessage, "warning");
		if ($sWarningMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sWarningMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sWarningMessage;
			$html .= "<div class=\"alert alert-warning ewWarning\">" . $sWarningMessage . "</div>";
			$_SESSION[EW_SESSION_WARNING_MESSAGE] = ""; // Clear message in Session
		}

		// Success message
		$sSuccessMessage = $this->getSuccessMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sSuccessMessage, "success");
		if ($sSuccessMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sSuccessMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sSuccessMessage;
			$html .= "<div class=\"alert alert-success ewSuccess\">" . $sSuccessMessage . "</div>";
			$_SESSION[EW_SESSION_SUCCESS_MESSAGE] = ""; // Clear message in Session
		}

		// Failure message
		$sErrorMessage = $this->getFailureMessage();
		if (method_exists($this, "Message_Showing"))
			$this->Message_Showing($sErrorMessage, "failure");
		if ($sErrorMessage <> "") { // Message in Session, display
			if (!$hidden)
				$sErrorMessage = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>" . $sErrorMessage;
			$html .= "<div class=\"alert alert-danger ewError\">" . $sErrorMessage . "</div>";
			$_SESSION[EW_SESSION_FAILURE_MESSAGE] = ""; // Clear message in Session
		}
		echo "<div class=\"ewMessageDialog\"" . (($hidden) ? " style=\"display: none;\"" : "") . ">" . $html . "</div>";
	}
	var $PageHeader;
	var $PageFooter;

	// Show Page Header
	function ShowPageHeader() {
		$sHeader = $this->PageHeader;
		$this->Page_DataRendering($sHeader);
		if ($sHeader <> "") { // Header exists, display
			echo "<p>" . $sHeader . "</p>";
		}
	}

	// Show Page Footer
	function ShowPageFooter() {
		$sFooter = $this->PageFooter;
		$this->Page_DataRendered($sFooter);
		if ($sFooter <> "") { // Footer exists, display
			echo "<p>" . $sFooter . "</p>";
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm;
		if ($this->UseTokenInUrl) {
			if ($objForm)
				return ($this->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($this->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}
	var $Token = "";
	var $TokenTimeout = 0;
	var $CheckToken = EW_CHECK_TOKEN;
	var $CheckTokenFn = "ew_CheckToken";
	var $CreateTokenFn = "ew_CreateToken";

	// Valid Post
	function ValidPost() {
		if (!$this->CheckToken || !ew_IsPost())
			return TRUE;
		if (!isset($_POST[EW_TOKEN_NAME]))
			return FALSE;
		$fn = $this->CheckTokenFn;
		if (is_callable($fn))
			return $fn($_POST[EW_TOKEN_NAME], $this->TokenTimeout);
		return FALSE;
	}

	// Create Token
	function CreateToken() {
		global $gsToken;
		if ($this->CheckToken) {
			$fn = $this->CreateTokenFn;
			if ($this->Token == "" && is_callable($fn)) // Create token
				$this->Token = $fn();
			$gsToken = $this->Token; // Save to global variable
		}
	}

	//
	// Page class constructor
	//
	function __construct() {
		global $conn, $Language;
		global $UserTable, $UserTableConn;
		$GLOBALS["Page"] = &$this;
		$this->TokenTimeout = ew_SessionTimeoutTime();

		// Language object
		if (!isset($Language)) $Language = new cLanguage();

		// Parent constuctor
		parent::__construct();

		// Table object (peserta)
		if (!isset($GLOBALS["peserta"]) || get_class($GLOBALS["peserta"]) == "cpeserta") {
			$GLOBALS["peserta"] = &$this;
			$GLOBALS["Table"] = &$GLOBALS["peserta"];
		}

		// Table object (employees)
		if (!isset($GLOBALS['employees'])) $GLOBALS['employees'] = new cemployees();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'addopt', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'peserta', TRUE);

		// Start timer
		if (!isset($GLOBALS["gTimer"]))
			$GLOBALS["gTimer"] = new cTimer();

		// Debug message
		ew_LoadDebugMsg();

		// Open connection
		if (!isset($conn))
			$conn = ew_Connect($this->DBID);

		// User table object (employees)
		if (!isset($UserTable)) {
			$UserTable = new cemployees();
			$UserTableConn = Conn($UserTable->DBID);
		}
	}

	//
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsCustomExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;

		// User profile
		$UserProfile = new cUserProfile();

		// Security
		$Security = new cAdvancedSecurity();
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loading();
		$Security->LoadCurrentUserLevel($this->ProjectID . $this->TableName);
		if ($Security->IsLoggedIn()) $Security->TablePermission_Loaded();
		if (!$Security->CanAdd()) {
			$Security->SaveLastUrl();
			$this->setFailureMessage(ew_DeniedMsg()); // Set no permission
			if ($Security->CanList())
				$this->Page_Terminate(ew_GetUrl("pesertalist.php"));
			else
				$this->Page_Terminate(ew_GetUrl("login.php"));
		}

		// NOTE: Security object may be needed in other part of the script, skip set to Nothing
		// 
		// Security = null;
		// 
		// Create form object

		$objForm = new cFormObj();
		$this->CurrentAction = (@$_GET["a"] <> "") ? $_GET["a"] : @$_POST["a_list"]; // Set up current action
		$this->pes_nama->SetVisibility();
		$this->pes_alamat->SetVisibility();
		$this->pes_hp->SetVisibility();
		$this->pes_foto->SetVisibility();
		$this->pes_luas_lahan->SetVisibility();
		$this->pes_r_tanam_tgl->SetVisibility();
		$this->pes_foto_lahan->SetVisibility();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();

		// Check token
		if (!$this->ValidPost()) {
			echo $Language->Phrase("InvalidPostRequest");
			$this->Page_Terminate();
			exit();
		}

		// Process auto fill
		if (@$_POST["ajax"] == "autofill") {
			$results = $this->GetAutoFill(@$_POST["name"], @$_POST["q"]);
			if ($results) {

				// Clean output buffer
				if (!EW_DEBUG_ENABLED && ob_get_length())
					ob_end_clean();
				echo $results;
				$this->Page_Terminate();
				exit();
			}
		}

		// Create Token
		$this->CreateToken();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $gsExportFile, $gTmpImages;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		// Export
		global $EW_EXPORT, $peserta;
		if ($this->CustomExport <> "" && $this->CustomExport == $this->Export && array_key_exists($this->CustomExport, $EW_EXPORT)) {
				$sContent = ob_get_contents();
			if ($gsExportFile == "") $gsExportFile = $this->TableVar;
			$class = $EW_EXPORT[$this->CustomExport];
			if (class_exists($class)) {
				$doc = new $class($peserta);
				$doc->Text = $sContent;
				if ($this->Export == "email")
					echo $this->ExportEmail($doc->Text);
				else
					$doc->Export();
				ew_DeleteTmpImages(); // Delete temp images
				exit();
			}
		}
		$this->Page_Redirecting($url);

		// Close connection
		ew_CloseConn();

		// Go to URL if specified
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			ew_SaveDebugMsg();
			header("Location: " . $url);
		}
		exit();
	}

	//
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsFormError;
		set_error_handler("ew_ErrorHandler");

		// Set up Breadcrumb
		//$this->SetupBreadcrumb(); // Not used

		$this->LoadRowValues(); // Load default values

		// Process form if post back
		if ($objForm->GetValue("a_addopt") <> "") {
			$this->CurrentAction = $objForm->GetValue("a_addopt"); // Get form action
			$this->LoadFormValues(); // Load form values

			// Validate form
			if (!$this->ValidateForm()) {
				$this->CurrentAction = "I"; // Form error, reset action
				$this->setFailureMessage($gsFormError);
			}
		} else { // Not post back
			$this->CurrentAction = "I"; // Display blank record
		}

		// Perform action based on action code
		switch ($this->CurrentAction) {
			case "I": // Blank record, no action required
				break;
			case "A": // Add new record
				$this->SendEmail = TRUE; // Send email on add success
				if ($this->AddRow()) { // Add successful
					$row = array();
					$row["x_pes_id"] = $this->pes_id->DbValue;
					$row["x_pes_nama"] = ew_ConvertToUtf8($this->pes_nama->DbValue);
					$row["x_pes_alamat"] = ew_ConvertToUtf8($this->pes_alamat->DbValue);
					$row["x_pes_hp"] = ew_ConvertToUtf8($this->pes_hp->DbValue);
					$row["x_pes_foto"] = ew_ConvertToUtf8($this->pes_foto->DbValue);
					$row["x_pes_luas_lahan"] = $this->pes_luas_lahan->DbValue;
					$row["x_pes_r_tanam_tgl"] = $this->pes_r_tanam_tgl->DbValue;
					$row["x_pes_foto_lahan"] = ew_ConvertToUtf8($this->pes_foto_lahan->DbValue);
					if (!EW_DEBUG_ENABLED && ob_get_length())
						ob_end_clean();
					ew_Header(FALSE, "utf-8", TRUE);
					echo ew_ArrayToJson(array($row));
				} else {
					$this->ShowMessage();
				}
				$this->Page_Terminate();
				exit();
		}

		// Render row
		$this->RowType = EW_ROWTYPE_ADD; // Render add type
		$this->ResetAttrs();
		$this->RenderRow();
	}

	// Get upload files
	function GetUploadFiles() {
		global $objForm, $Language;

		// Get upload data
		$this->pes_foto->Upload->Index = $objForm->Index;
		$this->pes_foto->Upload->UploadFile();
		$this->pes_foto->CurrentValue = $this->pes_foto->Upload->FileName;
		$this->pes_foto_lahan->Upload->Index = $objForm->Index;
		$this->pes_foto_lahan->Upload->UploadFile();
		$this->pes_foto_lahan->CurrentValue = $this->pes_foto_lahan->Upload->FileName;
	}

	// Load default values
	function LoadDefaultValues() {
		$this->pes_id->CurrentValue = NULL;
		$this->pes_id->OldValue = $this->pes_id->CurrentValue;
		$this->pes_nama->CurrentValue = NULL;
		$this->pes_nama->OldValue = $this->pes_nama->CurrentValue;
		$this->pes_alamat->CurrentValue = NULL;
		$this->pes_alamat->OldValue = $this->pes_alamat->CurrentValue;
		$this->pes_hp->CurrentValue = NULL;
		$this->pes_hp->OldValue = $this->pes_hp->CurrentValue;
		$this->pes_foto->Upload->DbValue = NULL;
		$this->pes_foto->OldValue = $this->pes_foto->Upload->DbValue;
		$this->pes_foto->CurrentValue = NULL; // Clear file related field
		$this->pes_luas_lahan->CurrentValue = NULL;
		$this->pes_luas_lahan->OldValue = $this->pes_luas_lahan->CurrentValue;
		$this->pes_r_tanam_tgl->CurrentValue = NULL;
		$this->pes_r_tanam_tgl->OldValue = $this->pes_r_tanam_tgl->CurrentValue;
		$this->pes_foto_lahan->Upload->DbValue = NULL;
		$this->pes_foto_lahan->OldValue = $this->pes_foto_lahan->Upload->DbValue;
		$this->pes_foto_lahan->CurrentValue = NULL; // Clear file related field
	}

	// Load form values
	function LoadFormValues() {

		// Load from form
		global $objForm;
		$this->GetUploadFiles(); // Get upload files
		if (!$this->pes_nama->FldIsDetailKey) {
			$this->pes_nama->setFormValue(ew_ConvertFromUtf8($objForm->GetValue("x_pes_nama")));
		}
		if (!$this->pes_alamat->FldIsDetailKey) {
			$this->pes_alamat->setFormValue(ew_ConvertFromUtf8($objForm->GetValue("x_pes_alamat")));
		}
		if (!$this->pes_hp->FldIsDetailKey) {
			$this->pes_hp->setFormValue(ew_ConvertFromUtf8($objForm->GetValue("x_pes_hp")));
		}
		if (!$this->pes_luas_lahan->FldIsDetailKey) {
			$this->pes_luas_lahan->setFormValue(ew_ConvertFromUtf8($objForm->GetValue("x_pes_luas_lahan")));
		}
		if (!$this->pes_r_tanam_tgl->FldIsDetailKey) {
			$this->pes_r_tanam_tgl->setFormValue(ew_ConvertFromUtf8($objForm->GetValue("x_pes_r_tanam_tgl")));
			$this->pes_r_tanam_tgl->CurrentValue = ew_UnFormatDateTime($this->pes_r_tanam_tgl->CurrentValue, 0);
		}
	}

	// Restore form values
	function RestoreFormValues() {
		global $objForm;
		$this->pes_nama->CurrentValue = ew_ConvertToUtf8($this->pes_nama->FormValue);
		$this->pes_alamat->CurrentValue = ew_ConvertToUtf8($this->pes_alamat->FormValue);
		$this->pes_hp->CurrentValue = ew_ConvertToUtf8($this->pes_hp->FormValue);
		$this->pes_luas_lahan->CurrentValue = ew_ConvertToUtf8($this->pes_luas_lahan->FormValue);
		$this->pes_r_tanam_tgl->CurrentValue = ew_ConvertToUtf8($this->pes_r_tanam_tgl->FormValue);
		$this->pes_r_tanam_tgl->CurrentValue = ew_UnFormatDateTime($this->pes_r_tanam_tgl->CurrentValue, 0);
	}

	// Load row based on key values
	function LoadRow() {
		global $Security, $Language;
		$sFilter = $this->KeyFilter();

		// Call Row Selecting event
		$this->Row_Selecting($sFilter);

		// Load SQL based on filter
		$this->CurrentFilter = $sFilter;
		$sSql = $this->SQL();
		$conn = &$this->Connection();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql, $conn);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues($rs = NULL) {
		if ($rs && !$rs->EOF)
			$row = $rs->fields;
		else
			$row = $this->NewRow(); 

		// Call Row Selected event
		$this->Row_Selected($row);
		if (!$rs || $rs->EOF)
			return;
		$this->pes_id->setDbValue($row['pes_id']);
		$this->pes_nama->setDbValue($row['pes_nama']);
		$this->pes_alamat->setDbValue($row['pes_alamat']);
		$this->pes_hp->setDbValue($row['pes_hp']);
		$this->pes_foto->Upload->DbValue = $row['pes_foto'];
		$this->pes_foto->setDbValue($this->pes_foto->Upload->DbValue);
		$this->pes_luas_lahan->setDbValue($row['pes_luas_lahan']);
		$this->pes_r_tanam_tgl->setDbValue($row['pes_r_tanam_tgl']);
		$this->pes_foto_lahan->Upload->DbValue = $row['pes_foto_lahan'];
		$this->pes_foto_lahan->setDbValue($this->pes_foto_lahan->Upload->DbValue);
	}

	// Return a row with default values
	function NewRow() {
		$this->LoadDefaultValues();
		$row = array();
		$row['pes_id'] = $this->pes_id->CurrentValue;
		$row['pes_nama'] = $this->pes_nama->CurrentValue;
		$row['pes_alamat'] = $this->pes_alamat->CurrentValue;
		$row['pes_hp'] = $this->pes_hp->CurrentValue;
		$row['pes_foto'] = $this->pes_foto->Upload->DbValue;
		$row['pes_luas_lahan'] = $this->pes_luas_lahan->CurrentValue;
		$row['pes_r_tanam_tgl'] = $this->pes_r_tanam_tgl->CurrentValue;
		$row['pes_foto_lahan'] = $this->pes_foto_lahan->Upload->DbValue;
		return $row;
	}

	// Load DbValue from recordset
	function LoadDbValues(&$rs) {
		if (!$rs || !is_array($rs) && $rs->EOF)
			return;
		$row = is_array($rs) ? $rs : $rs->fields;
		$this->pes_id->DbValue = $row['pes_id'];
		$this->pes_nama->DbValue = $row['pes_nama'];
		$this->pes_alamat->DbValue = $row['pes_alamat'];
		$this->pes_hp->DbValue = $row['pes_hp'];
		$this->pes_foto->Upload->DbValue = $row['pes_foto'];
		$this->pes_luas_lahan->DbValue = $row['pes_luas_lahan'];
		$this->pes_r_tanam_tgl->DbValue = $row['pes_r_tanam_tgl'];
		$this->pes_foto_lahan->Upload->DbValue = $row['pes_foto_lahan'];
	}

	// Render row values based on field settings
	function RenderRow() {
		global $Security, $Language, $gsLanguage;

		// Initialize URLs
		// Call Row_Rendering event

		$this->Row_Rendering();

		// Common render codes for all row types
		// pes_id
		// pes_nama
		// pes_alamat
		// pes_hp
		// pes_foto
		// pes_luas_lahan
		// pes_r_tanam_tgl
		// pes_foto_lahan

		if ($this->RowType == EW_ROWTYPE_VIEW) { // View row

		// pes_id
		$this->pes_id->ViewValue = $this->pes_id->CurrentValue;
		$this->pes_id->ViewCustomAttributes = "";

		// pes_nama
		$this->pes_nama->ViewValue = $this->pes_nama->CurrentValue;
		$this->pes_nama->ViewCustomAttributes = "";

		// pes_alamat
		$this->pes_alamat->ViewValue = $this->pes_alamat->CurrentValue;
		$this->pes_alamat->ViewCustomAttributes = "";

		// pes_hp
		$this->pes_hp->ViewValue = $this->pes_hp->CurrentValue;
		$this->pes_hp->ViewCustomAttributes = "";

		// pes_foto
		$this->pes_foto->UploadPath = "foto_peserta";
		if (!ew_Empty($this->pes_foto->Upload->DbValue)) {
			$this->pes_foto->ImageWidth = 60;
			$this->pes_foto->ImageHeight = 60;
			$this->pes_foto->ImageAlt = $this->pes_foto->FldAlt();
			$this->pes_foto->ViewValue = $this->pes_foto->Upload->DbValue;
		} else {
			$this->pes_foto->ViewValue = "";
		}
		$this->pes_foto->ViewCustomAttributes = "";

		// pes_luas_lahan
		$this->pes_luas_lahan->ViewValue = $this->pes_luas_lahan->CurrentValue;
		$this->pes_luas_lahan->CellCssStyle .= "text-align: right;";
		$this->pes_luas_lahan->ViewCustomAttributes = "";

		// pes_r_tanam_tgl
		$this->pes_r_tanam_tgl->ViewValue = $this->pes_r_tanam_tgl->CurrentValue;
		$this->pes_r_tanam_tgl->ViewValue = ew_FormatDateTime($this->pes_r_tanam_tgl->ViewValue, 0);
		$this->pes_r_tanam_tgl->ViewCustomAttributes = "";

		// pes_foto_lahan
		$this->pes_foto_lahan->UploadPath = "foto_potensi_lahan";
		if (!ew_Empty($this->pes_foto_lahan->Upload->DbValue)) {
			$this->pes_foto_lahan->ImageWidth = 80;
			$this->pes_foto_lahan->ImageHeight = 60;
			$this->pes_foto_lahan->ImageAlt = $this->pes_foto_lahan->FldAlt();
			$this->pes_foto_lahan->ViewValue = $this->pes_foto_lahan->Upload->DbValue;
		} else {
			$this->pes_foto_lahan->ViewValue = "";
		}
		$this->pes_foto_lahan->ViewCustomAttributes = "";

			// pes_nama
			$this->pes_nama->LinkCustomAttributes = "";
			$this->pes_nama->HrefValue = "";
			$this->pes_nama->TooltipValue = "";

			// pes_alamat
			$this->pes_alamat->LinkCustomAttributes = "";
			$this->pes_alamat->HrefValue = "";
			$this->pes_alamat->TooltipValue = "";

			// pes_hp
			$this->pes_hp->LinkCustomAttributes = "";
			$this->pes_hp->HrefValue = "";
			$this->pes_hp->TooltipValue = "";

			// pes_foto
			$this->pes_foto->LinkCustomAttributes = "";
			$this->pes_foto->UploadPath = "foto_peserta";
			if (!ew_Empty($this->pes_foto->Upload->DbValue)) {
				$this->pes_foto->HrefValue = ew_GetFileUploadUrl($this->pes_foto, $this->pes_foto->Upload->DbValue); // Add prefix/suffix
				$this->pes_foto->LinkAttrs["target"] = ""; // Add target
				if ($this->Export <> "") $this->pes_foto->HrefValue = ew_FullUrl($this->pes_foto->HrefValue, "href");
			} else {
				$this->pes_foto->HrefValue = "";
			}
			$this->pes_foto->HrefValue2 = $this->pes_foto->UploadPath . $this->pes_foto->Upload->DbValue;
			$this->pes_foto->TooltipValue = "";
			if ($this->pes_foto->UseColorbox) {
				if (ew_Empty($this->pes_foto->TooltipValue))
					$this->pes_foto->LinkAttrs["title"] = $Language->Phrase("ViewImageGallery");
				$this->pes_foto->LinkAttrs["data-rel"] = "peserta_x_pes_foto";
				ew_AppendClass($this->pes_foto->LinkAttrs["class"], "ewLightbox");
			}

			// pes_luas_lahan
			$this->pes_luas_lahan->LinkCustomAttributes = "";
			$this->pes_luas_lahan->HrefValue = "";
			$this->pes_luas_lahan->TooltipValue = "";

			// pes_r_tanam_tgl
			$this->pes_r_tanam_tgl->LinkCustomAttributes = "";
			$this->pes_r_tanam_tgl->HrefValue = "";
			$this->pes_r_tanam_tgl->TooltipValue = "";

			// pes_foto_lahan
			$this->pes_foto_lahan->LinkCustomAttributes = "";
			$this->pes_foto_lahan->UploadPath = "foto_potensi_lahan";
			if (!ew_Empty($this->pes_foto_lahan->Upload->DbValue)) {
				$this->pes_foto_lahan->HrefValue = "%u"; // Add prefix/suffix
				$this->pes_foto_lahan->LinkAttrs["target"] = ""; // Add target
				if ($this->Export <> "") $this->pes_foto_lahan->HrefValue = ew_FullUrl($this->pes_foto_lahan->HrefValue, "href");
			} else {
				$this->pes_foto_lahan->HrefValue = "";
			}
			$this->pes_foto_lahan->HrefValue2 = $this->pes_foto_lahan->UploadPath . $this->pes_foto_lahan->Upload->DbValue;
			$this->pes_foto_lahan->TooltipValue = "";
			if ($this->pes_foto_lahan->UseColorbox) {
				if (ew_Empty($this->pes_foto_lahan->TooltipValue))
					$this->pes_foto_lahan->LinkAttrs["title"] = $Language->Phrase("ViewImageGallery");
				$this->pes_foto_lahan->LinkAttrs["data-rel"] = "peserta_x_pes_foto_lahan";
				ew_AppendClass($this->pes_foto_lahan->LinkAttrs["class"], "ewLightbox");
			}
		} elseif ($this->RowType == EW_ROWTYPE_ADD) { // Add row

			// pes_nama
			$this->pes_nama->EditAttrs["class"] = "form-control";
			$this->pes_nama->EditCustomAttributes = "";
			$this->pes_nama->EditValue = ew_HtmlEncode($this->pes_nama->CurrentValue);
			$this->pes_nama->PlaceHolder = ew_RemoveHtml($this->pes_nama->FldCaption());

			// pes_alamat
			$this->pes_alamat->EditAttrs["class"] = "form-control";
			$this->pes_alamat->EditCustomAttributes = "";
			$this->pes_alamat->EditValue = ew_HtmlEncode($this->pes_alamat->CurrentValue);
			$this->pes_alamat->PlaceHolder = ew_RemoveHtml($this->pes_alamat->FldCaption());

			// pes_hp
			$this->pes_hp->EditAttrs["class"] = "form-control";
			$this->pes_hp->EditCustomAttributes = "";
			$this->pes_hp->EditValue = ew_HtmlEncode($this->pes_hp->CurrentValue);
			$this->pes_hp->PlaceHolder = ew_RemoveHtml($this->pes_hp->FldCaption());

			// pes_foto
			$this->pes_foto->EditAttrs["class"] = "form-control";
			$this->pes_foto->EditCustomAttributes = "";
			$this->pes_foto->UploadPath = "foto_peserta";
			if (!ew_Empty($this->pes_foto->Upload->DbValue)) {
				$this->pes_foto->ImageWidth = 60;
				$this->pes_foto->ImageHeight = 60;
				$this->pes_foto->ImageAlt = $this->pes_foto->FldAlt();
				$this->pes_foto->EditValue = $this->pes_foto->Upload->DbValue;
			} else {
				$this->pes_foto->EditValue = "";
			}
			if (!ew_Empty($this->pes_foto->CurrentValue))
					$this->pes_foto->Upload->FileName = $this->pes_foto->CurrentValue;
			if ($this->CurrentAction == "I" && !$this->EventCancelled) ew_RenderUploadField($this->pes_foto);

			// pes_luas_lahan
			$this->pes_luas_lahan->EditAttrs["class"] = "form-control";
			$this->pes_luas_lahan->EditCustomAttributes = "";
			$this->pes_luas_lahan->EditValue = ew_HtmlEncode($this->pes_luas_lahan->CurrentValue);
			$this->pes_luas_lahan->PlaceHolder = ew_RemoveHtml($this->pes_luas_lahan->FldCaption());

			// pes_r_tanam_tgl
			$this->pes_r_tanam_tgl->EditAttrs["class"] = "form-control";
			$this->pes_r_tanam_tgl->EditCustomAttributes = "";
			$this->pes_r_tanam_tgl->EditValue = ew_HtmlEncode(ew_FormatDateTime($this->pes_r_tanam_tgl->CurrentValue, 8));
			$this->pes_r_tanam_tgl->PlaceHolder = ew_RemoveHtml($this->pes_r_tanam_tgl->FldCaption());

			// pes_foto_lahan
			$this->pes_foto_lahan->EditAttrs["class"] = "form-control";
			$this->pes_foto_lahan->EditCustomAttributes = "";
			$this->pes_foto_lahan->UploadPath = "foto_potensi_lahan";
			if (!ew_Empty($this->pes_foto_lahan->Upload->DbValue)) {
				$this->pes_foto_lahan->ImageWidth = 80;
				$this->pes_foto_lahan->ImageHeight = 60;
				$this->pes_foto_lahan->ImageAlt = $this->pes_foto_lahan->FldAlt();
				$this->pes_foto_lahan->EditValue = $this->pes_foto_lahan->Upload->DbValue;
			} else {
				$this->pes_foto_lahan->EditValue = "";
			}
			if (!ew_Empty($this->pes_foto_lahan->CurrentValue))
					$this->pes_foto_lahan->Upload->FileName = $this->pes_foto_lahan->CurrentValue;
			if ($this->CurrentAction == "I" && !$this->EventCancelled) ew_RenderUploadField($this->pes_foto_lahan);

			// Add refer script
			// pes_nama

			$this->pes_nama->LinkCustomAttributes = "";
			$this->pes_nama->HrefValue = "";

			// pes_alamat
			$this->pes_alamat->LinkCustomAttributes = "";
			$this->pes_alamat->HrefValue = "";

			// pes_hp
			$this->pes_hp->LinkCustomAttributes = "";
			$this->pes_hp->HrefValue = "";

			// pes_foto
			$this->pes_foto->LinkCustomAttributes = "";
			$this->pes_foto->UploadPath = "foto_peserta";
			if (!ew_Empty($this->pes_foto->Upload->DbValue)) {
				$this->pes_foto->HrefValue = ew_GetFileUploadUrl($this->pes_foto, $this->pes_foto->Upload->DbValue); // Add prefix/suffix
				$this->pes_foto->LinkAttrs["target"] = ""; // Add target
				if ($this->Export <> "") $this->pes_foto->HrefValue = ew_FullUrl($this->pes_foto->HrefValue, "href");
			} else {
				$this->pes_foto->HrefValue = "";
			}
			$this->pes_foto->HrefValue2 = $this->pes_foto->UploadPath . $this->pes_foto->Upload->DbValue;

			// pes_luas_lahan
			$this->pes_luas_lahan->LinkCustomAttributes = "";
			$this->pes_luas_lahan->HrefValue = "";

			// pes_r_tanam_tgl
			$this->pes_r_tanam_tgl->LinkCustomAttributes = "";
			$this->pes_r_tanam_tgl->HrefValue = "";

			// pes_foto_lahan
			$this->pes_foto_lahan->LinkCustomAttributes = "";
			$this->pes_foto_lahan->UploadPath = "foto_potensi_lahan";
			if (!ew_Empty($this->pes_foto_lahan->Upload->DbValue)) {
				$this->pes_foto_lahan->HrefValue = "%u"; // Add prefix/suffix
				$this->pes_foto_lahan->LinkAttrs["target"] = ""; // Add target
				if ($this->Export <> "") $this->pes_foto_lahan->HrefValue = ew_FullUrl($this->pes_foto_lahan->HrefValue, "href");
			} else {
				$this->pes_foto_lahan->HrefValue = "";
			}
			$this->pes_foto_lahan->HrefValue2 = $this->pes_foto_lahan->UploadPath . $this->pes_foto_lahan->Upload->DbValue;
		}
		if ($this->RowType == EW_ROWTYPE_ADD || $this->RowType == EW_ROWTYPE_EDIT || $this->RowType == EW_ROWTYPE_SEARCH) // Add/Edit/Search row
			$this->SetupFieldTitles();

		// Call Row Rendered event
		if ($this->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$this->Row_Rendered();
	}

	// Validate form
	function ValidateForm() {
		global $Language, $gsFormError;

		// Initialize form error message
		$gsFormError = "";

		// Check if validation required
		if (!EW_SERVER_VALIDATE)
			return ($gsFormError == "");
		if (!ew_CheckInteger($this->pes_luas_lahan->FormValue)) {
			ew_AddMessage($gsFormError, $this->pes_luas_lahan->FldErrMsg());
		}
		if (!ew_CheckDateDef($this->pes_r_tanam_tgl->FormValue)) {
			ew_AddMessage($gsFormError, $this->pes_r_tanam_tgl->FldErrMsg());
		}

		// Return validate result
		$ValidateForm = ($gsFormError == "");

		// Call Form_CustomValidate event
		$sFormCustomError = "";
		$ValidateForm = $ValidateForm && $this->Form_CustomValidate($sFormCustomError);
		if ($sFormCustomError <> "") {
			ew_AddMessage($gsFormError, $sFormCustomError);
		}
		return $ValidateForm;
	}

	// Add record
	function AddRow($rsold = NULL) {
		global $Language, $Security;
		$conn = &$this->Connection();

		// Load db values from rsold
		$this->LoadDbValues($rsold);
		if ($rsold) {
			$this->pes_foto->OldUploadPath = "foto_peserta";
			$this->pes_foto->UploadPath = $this->pes_foto->OldUploadPath;
			$this->pes_foto_lahan->OldUploadPath = "foto_potensi_lahan";
			$this->pes_foto_lahan->UploadPath = $this->pes_foto_lahan->OldUploadPath;
		}
		$rsnew = array();

		// pes_nama
		$this->pes_nama->SetDbValueDef($rsnew, $this->pes_nama->CurrentValue, NULL, FALSE);

		// pes_alamat
		$this->pes_alamat->SetDbValueDef($rsnew, $this->pes_alamat->CurrentValue, NULL, FALSE);

		// pes_hp
		$this->pes_hp->SetDbValueDef($rsnew, $this->pes_hp->CurrentValue, NULL, FALSE);

		// pes_foto
		if ($this->pes_foto->Visible && !$this->pes_foto->Upload->KeepFile) {
			$this->pes_foto->Upload->DbValue = ""; // No need to delete old file
			if ($this->pes_foto->Upload->FileName == "") {
				$rsnew['pes_foto'] = NULL;
			} else {
				$rsnew['pes_foto'] = $this->pes_foto->Upload->FileName;
			}
			$this->pes_foto->ImageWidth = 600; // Resize width
			$this->pes_foto->ImageHeight = 600; // Resize height
		}

		// pes_luas_lahan
		$this->pes_luas_lahan->SetDbValueDef($rsnew, $this->pes_luas_lahan->CurrentValue, NULL, FALSE);

		// pes_r_tanam_tgl
		$this->pes_r_tanam_tgl->SetDbValueDef($rsnew, ew_UnFormatDateTime($this->pes_r_tanam_tgl->CurrentValue, 0), NULL, FALSE);

		// pes_foto_lahan
		if ($this->pes_foto_lahan->Visible && !$this->pes_foto_lahan->Upload->KeepFile) {
			$this->pes_foto_lahan->Upload->DbValue = ""; // No need to delete old file
			if ($this->pes_foto_lahan->Upload->FileName == "") {
				$rsnew['pes_foto_lahan'] = NULL;
			} else {
				$rsnew['pes_foto_lahan'] = $this->pes_foto_lahan->Upload->FileName;
			}
			$this->pes_foto_lahan->ImageWidth = 800; // Resize width
			$this->pes_foto_lahan->ImageHeight = 600; // Resize height
		}
		if ($this->pes_foto->Visible && !$this->pes_foto->Upload->KeepFile) {
			$this->pes_foto->UploadPath = "foto_peserta";
			$OldFiles = ew_Empty($this->pes_foto->Upload->DbValue) ? array() : array($this->pes_foto->Upload->DbValue);
			if (!ew_Empty($this->pes_foto->Upload->FileName)) {
				$NewFiles = array($this->pes_foto->Upload->FileName);
				$NewFileCount = count($NewFiles);
				for ($i = 0; $i < $NewFileCount; $i++) {
					$fldvar = ($this->pes_foto->Upload->Index < 0) ? $this->pes_foto->FldVar : substr($this->pes_foto->FldVar, 0, 1) . $this->pes_foto->Upload->Index . substr($this->pes_foto->FldVar, 1);
					if ($NewFiles[$i] <> "") {
						$file = $NewFiles[$i];
						if (file_exists(ew_UploadTempPath($fldvar, $this->pes_foto->TblVar) . $file)) {
							$OldFileFound = FALSE;
							$OldFileCount = count($OldFiles);
							for ($j = 0; $j < $OldFileCount; $j++) {
								$file1 = $OldFiles[$j];
								if ($file1 == $file) { // Old file found, no need to delete anymore
									unset($OldFiles[$j]);
									$OldFileFound = TRUE;
									break;
								}
							}
							if ($OldFileFound) // No need to check if file exists further
								continue;
							$file1 = ew_UploadFileNameEx($this->pes_foto->PhysicalUploadPath(), $file); // Get new file name
							if ($file1 <> $file) { // Rename temp file
								while (file_exists(ew_UploadTempPath($fldvar, $this->pes_foto->TblVar) . $file1) || file_exists($this->pes_foto->PhysicalUploadPath() . $file1)) // Make sure no file name clash
									$file1 = ew_UniqueFilename($this->pes_foto->PhysicalUploadPath(), $file1, TRUE); // Use indexed name
								rename(ew_UploadTempPath($fldvar, $this->pes_foto->TblVar) . $file, ew_UploadTempPath($fldvar, $this->pes_foto->TblVar) . $file1);
								$NewFiles[$i] = $file1;
							}
						}
					}
				}
				$this->pes_foto->Upload->DbValue = empty($OldFiles) ? "" : implode(EW_MULTIPLE_UPLOAD_SEPARATOR, $OldFiles);
				$this->pes_foto->Upload->FileName = implode(EW_MULTIPLE_UPLOAD_SEPARATOR, $NewFiles);
				$this->pes_foto->SetDbValueDef($rsnew, $this->pes_foto->Upload->FileName, NULL, FALSE);
			}
		}
		if ($this->pes_foto_lahan->Visible && !$this->pes_foto_lahan->Upload->KeepFile) {
			$this->pes_foto_lahan->UploadPath = "foto_potensi_lahan";
			$OldFiles = ew_Empty($this->pes_foto_lahan->Upload->DbValue) ? array() : explode(EW_MULTIPLE_UPLOAD_SEPARATOR, strval($this->pes_foto_lahan->Upload->DbValue));
			if (!ew_Empty($this->pes_foto_lahan->Upload->FileName)) {
				$NewFiles = explode(EW_MULTIPLE_UPLOAD_SEPARATOR, strval($this->pes_foto_lahan->Upload->FileName));
				$NewFileCount = count($NewFiles);
				for ($i = 0; $i < $NewFileCount; $i++) {
					$fldvar = ($this->pes_foto_lahan->Upload->Index < 0) ? $this->pes_foto_lahan->FldVar : substr($this->pes_foto_lahan->FldVar, 0, 1) . $this->pes_foto_lahan->Upload->Index . substr($this->pes_foto_lahan->FldVar, 1);
					if ($NewFiles[$i] <> "") {
						$file = $NewFiles[$i];
						if (file_exists(ew_UploadTempPath($fldvar, $this->pes_foto_lahan->TblVar) . $file)) {
							$OldFileFound = FALSE;
							$OldFileCount = count($OldFiles);
							for ($j = 0; $j < $OldFileCount; $j++) {
								$file1 = $OldFiles[$j];
								if ($file1 == $file) { // Old file found, no need to delete anymore
									unset($OldFiles[$j]);
									$OldFileFound = TRUE;
									break;
								}
							}
							if ($OldFileFound) // No need to check if file exists further
								continue;
							$file1 = ew_UploadFileNameEx($this->pes_foto_lahan->PhysicalUploadPath(), $file); // Get new file name
							if ($file1 <> $file) { // Rename temp file
								while (file_exists(ew_UploadTempPath($fldvar, $this->pes_foto_lahan->TblVar) . $file1) || file_exists($this->pes_foto_lahan->PhysicalUploadPath() . $file1)) // Make sure no file name clash
									$file1 = ew_UniqueFilename($this->pes_foto_lahan->PhysicalUploadPath(), $file1, TRUE); // Use indexed name
								rename(ew_UploadTempPath($fldvar, $this->pes_foto_lahan->TblVar) . $file, ew_UploadTempPath($fldvar, $this->pes_foto_lahan->TblVar) . $file1);
								$NewFiles[$i] = $file1;
							}
						}
					}
				}
				$this->pes_foto_lahan->Upload->DbValue = empty($OldFiles) ? "" : implode(EW_MULTIPLE_UPLOAD_SEPARATOR, $OldFiles);
				$this->pes_foto_lahan->Upload->FileName = implode(EW_MULTIPLE_UPLOAD_SEPARATOR, $NewFiles);
				$this->pes_foto_lahan->SetDbValueDef($rsnew, $this->pes_foto_lahan->Upload->FileName, NULL, FALSE);
			}
		}

		// Call Row Inserting event
		$rs = ($rsold == NULL) ? NULL : $rsold->fields;
		$bInsertRow = $this->Row_Inserting($rs, $rsnew);
		if ($bInsertRow) {
			$conn->raiseErrorFn = $GLOBALS["EW_ERROR_FN"];
			$AddRow = $this->Insert($rsnew);
			$conn->raiseErrorFn = '';
			if ($AddRow) {
				if ($this->pes_foto->Visible && !$this->pes_foto->Upload->KeepFile) {
					$OldFiles = ew_Empty($this->pes_foto->Upload->DbValue) ? array() : array($this->pes_foto->Upload->DbValue);
					if (!ew_Empty($this->pes_foto->Upload->FileName)) {
						$NewFiles = array($this->pes_foto->Upload->FileName);
						$NewFiles2 = array($rsnew['pes_foto']);
						$NewFileCount = count($NewFiles);
						for ($i = 0; $i < $NewFileCount; $i++) {
							$fldvar = ($this->pes_foto->Upload->Index < 0) ? $this->pes_foto->FldVar : substr($this->pes_foto->FldVar, 0, 1) . $this->pes_foto->Upload->Index . substr($this->pes_foto->FldVar, 1);
							if ($NewFiles[$i] <> "") {
								$file = ew_UploadTempPath($fldvar, $this->pes_foto->TblVar) . $NewFiles[$i];
								if (file_exists($file)) {
									if (@$NewFiles2[$i] <> "") // Use correct file name
										$NewFiles[$i] = $NewFiles2[$i];
									if (!$this->pes_foto->Upload->ResizeAndSaveToFile($this->pes_foto->ImageWidth, $this->pes_foto->ImageHeight, EW_THUMBNAIL_DEFAULT_QUALITY, $NewFiles[$i], TRUE, $i)) {
										$this->setFailureMessage($Language->Phrase("UploadErrMsg7"));
										return FALSE;
									}
								}
							}
						}
					} else {
						$NewFiles = array();
					}
					$OldFileCount = count($OldFiles);
					for ($i = 0; $i < $OldFileCount; $i++) {
						if ($OldFiles[$i] <> "" && !in_array($OldFiles[$i], $NewFiles))
							@unlink($this->pes_foto->OldPhysicalUploadPath() . $OldFiles[$i]);
					}
				}
				if ($this->pes_foto_lahan->Visible && !$this->pes_foto_lahan->Upload->KeepFile) {
					$OldFiles = ew_Empty($this->pes_foto_lahan->Upload->DbValue) ? array() : explode(EW_MULTIPLE_UPLOAD_SEPARATOR, strval($this->pes_foto_lahan->Upload->DbValue));
					if (!ew_Empty($this->pes_foto_lahan->Upload->FileName)) {
						$NewFiles = explode(EW_MULTIPLE_UPLOAD_SEPARATOR, $this->pes_foto_lahan->Upload->FileName);
						$NewFiles2 = explode(EW_MULTIPLE_UPLOAD_SEPARATOR, $rsnew['pes_foto_lahan']);
						$NewFileCount = count($NewFiles);
						for ($i = 0; $i < $NewFileCount; $i++) {
							$fldvar = ($this->pes_foto_lahan->Upload->Index < 0) ? $this->pes_foto_lahan->FldVar : substr($this->pes_foto_lahan->FldVar, 0, 1) . $this->pes_foto_lahan->Upload->Index . substr($this->pes_foto_lahan->FldVar, 1);
							if ($NewFiles[$i] <> "") {
								$file = ew_UploadTempPath($fldvar, $this->pes_foto_lahan->TblVar) . $NewFiles[$i];
								if (file_exists($file)) {
									if (@$NewFiles2[$i] <> "") // Use correct file name
										$NewFiles[$i] = $NewFiles2[$i];
									if (!$this->pes_foto_lahan->Upload->ResizeAndSaveToFile($this->pes_foto_lahan->ImageWidth, $this->pes_foto_lahan->ImageHeight, EW_THUMBNAIL_DEFAULT_QUALITY, $NewFiles[$i], TRUE, $i)) {
										$this->setFailureMessage($Language->Phrase("UploadErrMsg7"));
										return FALSE;
									}
								}
							}
						}
					} else {
						$NewFiles = array();
					}
					$OldFileCount = count($OldFiles);
					for ($i = 0; $i < $OldFileCount; $i++) {
						if ($OldFiles[$i] <> "" && !in_array($OldFiles[$i], $NewFiles))
							@unlink($this->pes_foto_lahan->OldPhysicalUploadPath() . $OldFiles[$i]);
					}
				}
			}
		} else {
			if ($this->getSuccessMessage() <> "" || $this->getFailureMessage() <> "") {

				// Use the message, do nothing
			} elseif ($this->CancelMessage <> "") {
				$this->setFailureMessage($this->CancelMessage);
				$this->CancelMessage = "";
			} else {
				$this->setFailureMessage($Language->Phrase("InsertCancelled"));
			}
			$AddRow = FALSE;
		}
		if ($AddRow) {

			// Call Row Inserted event
			$rs = ($rsold == NULL) ? NULL : $rsold->fields;
			$this->Row_Inserted($rs, $rsnew);
		}

		// pes_foto
		ew_CleanUploadTempPath($this->pes_foto, $this->pes_foto->Upload->Index);

		// pes_foto_lahan
		ew_CleanUploadTempPath($this->pes_foto_lahan, $this->pes_foto_lahan->Upload->Index);
		return $AddRow;
	}

	// Set up Breadcrumb
	function SetupBreadcrumb() {
		global $Breadcrumb, $Language;
		$Breadcrumb = new cBreadcrumb();
		$url = substr(ew_CurrentUrl(), strrpos(ew_CurrentUrl(), "/")+1);
		$Breadcrumb->Add("list", $this->TableVar, $this->AddMasterUrl("pesertalist.php"), "", $this->TableVar, TRUE);
		$PageId = "addopt";
		$Breadcrumb->Add("addopt", $PageId, $url);
	}

	// Setup lookup filters of a field
	function SetupLookupFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		}
	}

	// Setup AutoSuggest filters of a field
	function SetupAutoSuggestFilters($fld, $pageId = null) {
		global $gsLanguage;
		$pageId = $pageId ?: $this->PageID;
		switch ($fld->FldVar) {
		}
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	// $type = ''|'success'|'failure'|'warning'
	function Message_Showing(&$msg, $type) {
		if ($type == 'success') {

			//$msg = "your success message";
		} elseif ($type == 'failure') {

			//$msg = "your failure message";
		} elseif ($type == 'warning') {

			//$msg = "your warning message";
		} else {

			//$msg = "your message";
		}
	}

	// Page Render event
	function Page_Render() {

		//echo "Page Render";
	}

	// Page Data Rendering event
	function Page_DataRendering(&$header) {

		// Example:
		//$header = "your header";

	}

	// Page Data Rendered event
	function Page_DataRendered(&$footer) {

		// Example:
		//$footer = "your footer";

	}

	// Custom validate event
	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}
}
?>
<?php ew_Header(FALSE) ?>
<?php

// Create page object
if (!isset($peserta_addopt)) $peserta_addopt = new cpeserta_addopt();

// Page init
$peserta_addopt->Page_Init();

// Page main
$peserta_addopt->Page_Main();

// Global Page Rendering event (in userfn*.php)
Page_Rendering();

// Page Rendering event
$peserta_addopt->Page_Render();
?>
<script type="text/javascript">

// Form object
var CurrentPageID = EW_PAGE_ID = "addopt";
var CurrentForm = fpesertaaddopt = new ew_Form("fpesertaaddopt", "addopt");

// Validate form
fpesertaaddopt.Validate = function() {
	if (!this.ValidateRequired)
		return true; // Ignore validation
	var $ = jQuery, fobj = this.GetForm(), $fobj = $(fobj);
	if ($fobj.find("#a_confirm").val() == "F")
		return true;
	var elm, felm, uelm, addcnt = 0;
	var $k = $fobj.find("#" + this.FormKeyCountName); // Get key_count
	var rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1;
	var startcnt = (rowcnt == 0) ? 0 : 1; // Check rowcnt == 0 => Inline-Add
	var gridinsert = $fobj.find("#a_list").val() == "gridinsert";
	for (var i = startcnt; i <= rowcnt; i++) {
		var infix = ($k[0]) ? String(i) : "";
		$fobj.data("rowindex", infix);
			elm = this.GetElements("x" + infix + "_pes_luas_lahan");
			if (elm && !ew_CheckInteger(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($peserta->pes_luas_lahan->FldErrMsg()) ?>");
			elm = this.GetElements("x" + infix + "_pes_r_tanam_tgl");
			if (elm && !ew_CheckDateDef(elm.value))
				return this.OnError(elm, "<?php echo ew_JsEncode2($peserta->pes_r_tanam_tgl->FldErrMsg()) ?>");

			// Fire Form_CustomValidate event
			if (!this.Form_CustomValidate(fobj))
				return false;
	}
	return true;
}

// Form_CustomValidate event
fpesertaaddopt.Form_CustomValidate = 
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid.
 	return true;
 }

// Use JavaScript validation or not
fpesertaaddopt.ValidateRequired = <?php echo json_encode(EW_CLIENT_VALIDATE) ?>;

// Dynamic selection lists
// Form object for search

</script>
<script type="text/javascript">

// Write your client script here, no need to add script tags.
</script>
<?php
$peserta_addopt->ShowMessage();
?>
<form name="fpesertaaddopt" id="fpesertaaddopt" class="ewForm form-horizontal" action="pesertaaddopt.php" method="post">
<?php if ($peserta_addopt->CheckToken) { ?>
<input type="hidden" name="<?php echo EW_TOKEN_NAME ?>" value="<?php echo $peserta_addopt->Token ?>">
<?php } ?>
<input type="hidden" name="t" value="peserta">
<input type="hidden" name="a_addopt" id="a_addopt" value="A">
<?php if ($peserta->pes_nama->Visible) { // pes_nama ?>
	<div class="form-group">
		<label class="col-sm-2 control-label ewLabel" for="x_pes_nama"><?php echo $peserta->pes_nama->FldCaption() ?></label>
		<div class="col-sm-10">
<input type="text" data-table="peserta" data-field="x_pes_nama" name="x_pes_nama" id="x_pes_nama" size="30" maxlength="100" placeholder="<?php echo ew_HtmlEncode($peserta->pes_nama->getPlaceHolder()) ?>" value="<?php echo $peserta->pes_nama->EditValue ?>"<?php echo $peserta->pes_nama->EditAttributes() ?>>
</div>
	</div>
<?php } ?>
<?php if ($peserta->pes_alamat->Visible) { // pes_alamat ?>
	<div class="form-group">
		<label class="col-sm-2 control-label ewLabel" for="x_pes_alamat"><?php echo $peserta->pes_alamat->FldCaption() ?></label>
		<div class="col-sm-10">
<input type="text" data-table="peserta" data-field="x_pes_alamat" name="x_pes_alamat" id="x_pes_alamat" size="30" maxlength="200" placeholder="<?php echo ew_HtmlEncode($peserta->pes_alamat->getPlaceHolder()) ?>" value="<?php echo $peserta->pes_alamat->EditValue ?>"<?php echo $peserta->pes_alamat->EditAttributes() ?>>
</div>
	</div>
<?php } ?>
<?php if ($peserta->pes_hp->Visible) { // pes_hp ?>
	<div class="form-group">
		<label class="col-sm-2 control-label ewLabel" for="x_pes_hp"><?php echo $peserta->pes_hp->FldCaption() ?></label>
		<div class="col-sm-10">
<input type="text" data-table="peserta" data-field="x_pes_hp" name="x_pes_hp" id="x_pes_hp" size="30" maxlength="20" placeholder="<?php echo ew_HtmlEncode($peserta->pes_hp->getPlaceHolder()) ?>" value="<?php echo $peserta->pes_hp->EditValue ?>"<?php echo $peserta->pes_hp->EditAttributes() ?>>
</div>
	</div>
<?php } ?>
<?php if ($peserta->pes_foto->Visible) { // pes_foto ?>
	<div class="form-group">
		<label class="col-sm-2 control-label ewLabel"><?php echo $peserta->pes_foto->FldCaption() ?></label>
		<div class="col-sm-10">
<div id="fd_x_pes_foto">
<span title="<?php echo $peserta->pes_foto->FldTitle() ? $peserta->pes_foto->FldTitle() : $Language->Phrase("ChooseFile") ?>" class="btn btn-default btn-sm fileinput-button ewTooltip<?php if ($peserta->pes_foto->ReadOnly || $peserta->pes_foto->Disabled) echo " hide"; ?>" data-trigger="hover">
	<span><?php echo $Language->Phrase("ChooseFileBtn") ?></span>
	<input type="file" title=" " data-table="peserta" data-field="x_pes_foto" name="x_pes_foto" id="x_pes_foto"<?php echo $peserta->pes_foto->EditAttributes() ?>>
</span>
<input type="hidden" name="fn_x_pes_foto" id= "fn_x_pes_foto" value="<?php echo $peserta->pes_foto->Upload->FileName ?>">
<input type="hidden" name="fa_x_pes_foto" id= "fa_x_pes_foto" value="0">
<input type="hidden" name="fs_x_pes_foto" id= "fs_x_pes_foto" value="100">
<input type="hidden" name="fx_x_pes_foto" id= "fx_x_pes_foto" value="<?php echo $peserta->pes_foto->UploadAllowedFileExt ?>">
<input type="hidden" name="fm_x_pes_foto" id= "fm_x_pes_foto" value="<?php echo $peserta->pes_foto->UploadMaxFileSize ?>">
</div>
<table id="ft_x_pes_foto" class="table table-condensed pull-left ewUploadTable"><tbody class="files"></tbody></table>
</div>
	</div>
<?php } ?>
<?php if ($peserta->pes_luas_lahan->Visible) { // pes_luas_lahan ?>
	<div class="form-group">
		<label class="col-sm-2 control-label ewLabel" for="x_pes_luas_lahan"><?php echo $peserta->pes_luas_lahan->FldCaption() ?></label>
		<div class="col-sm-10">
<input type="text" data-table="peserta" data-field="x_pes_luas_lahan" name="x_pes_luas_lahan" id="x_pes_luas_lahan" size="30" placeholder="<?php echo ew_HtmlEncode($peserta->pes_luas_lahan->getPlaceHolder()) ?>" value="<?php echo $peserta->pes_luas_lahan->EditValue ?>"<?php echo $peserta->pes_luas_lahan->EditAttributes() ?>>
</div>
	</div>
<?php } ?>
<?php if ($peserta->pes_r_tanam_tgl->Visible) { // pes_r_tanam_tgl ?>
	<div class="form-group">
		<label class="col-sm-2 control-label ewLabel" for="x_pes_r_tanam_tgl"><?php echo $peserta->pes_r_tanam_tgl->FldCaption() ?></label>
		<div class="col-sm-10">
<input type="text" data-table="peserta" data-field="x_pes_r_tanam_tgl" name="x_pes_r_tanam_tgl" id="x_pes_r_tanam_tgl" placeholder="<?php echo ew_HtmlEncode($peserta->pes_r_tanam_tgl->getPlaceHolder()) ?>" value="<?php echo $peserta->pes_r_tanam_tgl->EditValue ?>"<?php echo $peserta->pes_r_tanam_tgl->EditAttributes() ?>>
<?php if (!$peserta->pes_r_tanam_tgl->ReadOnly && !$peserta->pes_r_tanam_tgl->Disabled && !isset($peserta->pes_r_tanam_tgl->EditAttrs["readonly"]) && !isset($peserta->pes_r_tanam_tgl->EditAttrs["disabled"])) { ?>
<script type="text/javascript">
ew_CreateDateTimePicker("fpesertaaddopt", "x_pes_r_tanam_tgl", {"ignoreReadonly":true,"useCurrent":false,"format":0});
</script>
<?php } ?>
</div>
	</div>
<?php } ?>
<?php if ($peserta->pes_foto_lahan->Visible) { // pes_foto_lahan ?>
	<div class="form-group">
		<label class="col-sm-2 control-label ewLabel"><?php echo $peserta->pes_foto_lahan->FldCaption() ?></label>
		<div class="col-sm-10">
<div id="fd_x_pes_foto_lahan">
<span title="<?php echo $peserta->pes_foto_lahan->FldTitle() ? $peserta->pes_foto_lahan->FldTitle() : $Language->Phrase("ChooseFiles") ?>" class="btn btn-default btn-sm fileinput-button ewTooltip<?php if ($peserta->pes_foto_lahan->ReadOnly || $peserta->pes_foto_lahan->Disabled) echo " hide"; ?>" data-trigger="hover">
	<span><?php echo $Language->Phrase("ChooseFileBtn") ?></span>
	<input type="file" title=" " data-table="peserta" data-field="x_pes_foto_lahan" name="x_pes_foto_lahan" id="x_pes_foto_lahan" multiple="multiple"<?php echo $peserta->pes_foto_lahan->EditAttributes() ?>>
</span>
<input type="hidden" name="fn_x_pes_foto_lahan" id= "fn_x_pes_foto_lahan" value="<?php echo $peserta->pes_foto_lahan->Upload->FileName ?>">
<input type="hidden" name="fa_x_pes_foto_lahan" id= "fa_x_pes_foto_lahan" value="0">
<input type="hidden" name="fs_x_pes_foto_lahan" id= "fs_x_pes_foto_lahan" value="100">
<input type="hidden" name="fx_x_pes_foto_lahan" id= "fx_x_pes_foto_lahan" value="<?php echo $peserta->pes_foto_lahan->UploadAllowedFileExt ?>">
<input type="hidden" name="fm_x_pes_foto_lahan" id= "fm_x_pes_foto_lahan" value="<?php echo $peserta->pes_foto_lahan->UploadMaxFileSize ?>">
<input type="hidden" name="fc_x_pes_foto_lahan" id= "fc_x_pes_foto_lahan" value="<?php echo $peserta->pes_foto_lahan->UploadMaxFileCount ?>">
</div>
<table id="ft_x_pes_foto_lahan" class="table table-condensed pull-left ewUploadTable"><tbody class="files"></tbody></table>
</div>
	</div>
<?php } ?>
</form>
<script type="text/javascript">
fpesertaaddopt.Init();
</script>
<script type="text/javascript">

// Write your table-specific startup script here
// document.write("page loaded");

</script>
<?php
$peserta_addopt->Page_Terminate();
?>
